﻿Imports System.ComponentModel
Imports System.Runtime.CompilerServices
Imports BassWaveFormDemo.ViewModel.Service

Public Class MainWindowViewModel

    Implements INotifyPropertyChanged

    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
    Public Overridable Sub RaisePropertyChanged(<CallerMemberName> propertyName As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
    End Sub

    Private audioService As BassLibService

    Private _bmp As BitmapSource = Nothing
    Public Property Bmp As BitmapSource
        Get
            Return _bmp
        End Get
        Set(ByVal value As BitmapSource)
            If _bmp IsNot value Then
                _bmp = value
                RaisePropertyChanged(NameOf(Bmp))
            End If
        End Set
    End Property

    Public Sub New()
        Dim p As String = ".mp3"
        audioService = DirectCast(ServiceManager.GetService(Of BassLibService), BassLibService)
        If audioService.Init() Then
            audioService.PlayFile(p)
            AddHandler audioService.WaveFormRendered, AddressOf WaveFormRendered
            audioService.CreateWaveForm(p, 1024, 768)
        End If
    End Sub

    Private Sub WaveFormRendered(sender As Object, bitmapSource As BitmapSource)
        Bmp = bitmapSource
    End Sub

End Class